' Add a reference to System.Web.
Imports System.Web

Public Class Form1
    Private Sub btnGoogle_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnGoogle.Click
        ' The basic map URL without the address information.
        Const URL_BASE As String = "http://maps.google.com/maps?f=q&hl=en&geocode=&time=&date=&ttype=&q=@ADDR@&ie=UTF8&t=@TYPE@"

        ' URL encode the street address.
        Dim addr As String = txtAddress.Text
        addr = HttpUtility.UrlEncode(txtAddress.Text, System.Text.Encoding.UTF8)

        ' Insert the encoded address into the base URL.
        Dim url As String = URL_BASE.Replace("@ADDR@", addr)

        ' Insert the proper type.
        Select Case cboGoogle.Text
            Case "Map"
                url = url.Replace("@TYPE@", "m")
            Case "Satellite"
                url = url.Replace("@TYPE@", "h")
            Case "Terrain"
                url = url.Replace("@TYPE@", "p")
        End Select

        ' "Execute" the URL to make the default browser display it.
        Process.Start(url)
    End Sub

    Private Sub btnYahoo_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnYahoo.Click
        ' The basic map URL without the address information.
        Const URL_FAST As String = "http://maps.yahoo.com/broadband#mvt=@TYPE@&q1=@ADDR@"
        Const URL_SLOW As String = "http://maps.yahoo.com/maps_result.php?q1=@ADDR@"

        ' Get broadband or dial-up base URL.
        Dim url As String
        If cboYahoo.Text = "Dial-Up" Then
            url = URL_SLOW
        Else
            url = URL_FAST
        End If

        ' URL encode the street address.
        Dim addr As String = txtAddress.Text
        addr = HttpUtility.UrlEncode(txtAddress.Text, System.Text.Encoding.UTF8)

        ' Insert the encoded address into the base URL.
        url = url.Replace("@ADDR@", addr)

        ' Insert the proper type.
        Select Case cboGoogle.Text
            Case "Map"
                url = url.Replace("@TYPE@", "m")
            Case "Satellite"
                url = url.Replace("@TYPE@", "s")
            Case "Hybrid"
                url = url.Replace("@TYPE@", "h")
        End Select

        ' "Execute" the URL to make the default browser display it.
        Process.Start(url)
    End Sub

    Private Sub Form1_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        cboGoogle.SelectedIndex = 0
        cboYahoo.SelectedIndex = 0
    End Sub
End Class
